#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=RD3Code.ico
#AutoIt3Wrapper_Outfile=RD3Code.exe
#AutoIt3Wrapper_Res_Comment=
#AutoIt3Wrapper_Res_Description=
#AutoIt3Wrapper_Res_Fileversion=0.1.0.5
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_ProductVersion=0.1
#AutoIt3Wrapper_Res_LegalCopyright=Copyright © 2017 Nicholas Regitz
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Run_Tidy=y
#AutoIt3Wrapper_Change2CUI=n
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Aut2Exe=Win98\Aut2Exe\Aut2ExeA.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

AutoItSetOption("TrayMenuMode", 1) ;Kein Menu
AutoItSetOption("TrayIconHide", 1) ;Kein TrayIcon

$exe = "RD3.exe"
$regpath = "HKEY_LOCAL_MACHINE\SOFTWARE\CODEMASTERS\Race Driver 3"

$Base = 0x400000
$Code1 = 0x32C26C
$Code2 = 0x32C274
$pID = 0

If ProcessExists($exe) Then
	$pID = ProcessExists($exe)
Else
	If FileExists(RegRead($regpath, "PATH_APPLICATION") & "\" & $exe) Then
		$pID = Run(RegRead($regpath, "PATH_APPLICATION") & "\" & $exe)
	Else
		MsgBox(0, "Error", "There is no running RD3.exe and no valid installation in registry.")
	EndIf
EndIf

If $pID Then
	$mID = _MemoryOpen($pID, 0x1F0FFF, 1)
	While ProcessExists($pID)
		If _MemoryRead($Base + $Code1, $mID, 'UINT') <> 0xFFFF Then
			_MemoryWrite($Base + $Code1, $mID, 0xFFFF, 'UINT')
		EndIf

		If _MemoryRead($Base + $Code2, $mID, 'UINT') <> 23 Then
			_MemoryWrite($Base + $Code2, $mID, 23, 'UINT')
		EndIf
		Sleep(5000)
	WEnd
	_MemoryClose($pID)
EndIf

Exit

Func _MemoryOpen($iv_Pid, $iv_DesiredAccess = 0x1F0FFF, $if_InheritHandle = 1)

	If Not ProcessExists($iv_Pid) Then
		SetError(1)
		Return 0
	EndIf

	Local $ah_Handle[2] = [DllOpen('kernel32.dll')]

	If @error Then
		SetError(2)
		Return 0
	EndIf

	Local $av_OpenProcess = DllCall($ah_Handle[0], 'int', 'OpenProcess', 'int', $iv_DesiredAccess, 'int', $if_InheritHandle, 'int', $iv_Pid)

	If @error Then
		DllClose($ah_Handle[0])
		SetError(3)
		Return 0
	EndIf

	$ah_Handle[1] = $av_OpenProcess[0]

	Return $ah_Handle

EndFunc   ;==>_MemoryOpen

Func _MemoryRead($iv_Address, $ah_Handle, $sv_Type = 'dword')

	If Not IsArray($ah_Handle) Then
		SetError(1)
		Return 0
	EndIf

	Local $v_Buffer = DllStructCreate($sv_Type)

	If @error Then
		SetError(@error + 1)
		Return 0
	EndIf

	DllCall($ah_Handle[0], 'int', 'ReadProcessMemory', 'int', $ah_Handle[1], 'int', $iv_Address, 'ptr', DllStructGetPtr($v_Buffer), 'int', DllStructGetSize($v_Buffer), 'int', '')

	If Not @error Then
		Local $v_Value = DllStructGetData($v_Buffer, 1)
		Return $v_Value
	Else
		SetError(6)
		Return 0
	EndIf

EndFunc   ;==>_MemoryRead

Func _MemoryWrite($iv_Address, $ah_Handle, $v_Data, $sv_Type = 'dword')

	If Not IsArray($ah_Handle) Then
		SetError(1)
		Return 0
	EndIf

	Local $v_Buffer = DllStructCreate($sv_Type)

	If @error Then
		SetError(@error + 1)
		Return 0
	Else
		DllStructSetData($v_Buffer, 1, $v_Data)
		If @error Then
			SetError(6)
			Return 0
		EndIf
	EndIf

	DllCall($ah_Handle[0], 'int', 'WriteProcessMemory', 'int', $ah_Handle[1], 'int', $iv_Address, 'ptr', DllStructGetPtr($v_Buffer), 'int', DllStructGetSize($v_Buffer), 'int', '')

	If Not @error Then
		Return 1
	Else
		SetError(7)
		Return 0
	EndIf

EndFunc   ;==>_MemoryWrite

Func _MemoryClose($ah_Handle)

	If Not IsArray($ah_Handle) Then
		SetError(1)
		Return 0
	EndIf

	DllCall($ah_Handle[0], 'int', 'CloseHandle', 'int', $ah_Handle[1])
	If Not @error Then
		DllClose($ah_Handle[0])
		Return 1
	Else
		DllClose($ah_Handle[0])
		SetError(2)
		Return 0
	EndIf

EndFunc   ;==>_MemoryClose
