#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=SETUP09.ICO
#AutoIt3Wrapper_Outfile=RD3Reg.exe
#AutoIt3Wrapper_Res_Comment=
#AutoIt3Wrapper_Res_Description=
#AutoIt3Wrapper_Res_Fileversion=0.1.0.5
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_ProductVersion=0.1
#AutoIt3Wrapper_Res_LegalCopyright=Copyright © 2016 Nicholas Regitz
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Run_Tidy=y
#AutoIt3Wrapper_Change2CUI=n
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Aut2Exe=LegacyAut2Exe\Aut2Exe_9x.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

AutoItSetOption("ExpandVarStrings", 1)

$title = "RD3 Registry Creator"
$exe = "RD3.exe"
$regpath = "HKEY_LOCAL_MACHINE\SOFTWARE\CODEMASTERS\Race Driver 3"
$gamedir = @ProgramFilesDir ;StringReplace(@WorkingDir, "\", "\\")
$name = ""
$name_ger = "DTM Race Driver 3"
$name_eur = "ToCa Race Driver 3"
$name_aus = "V8 Supercars 3"
$local = "" ;eur ger aus
$lang = "" ;eng fre ger ita spa

If FileExists(RegRead($regpath, "PATH_APPLICATION") & "\" & $exe) Then
	$gamedir = RegRead($regpath, "PATH_APPLICATION")
EndIf

$gamedir = FileSelectFolder("Please select your RaceDriver 3 directory", "", 0, $gamedir)
If @error Then
	Exit
EndIf
If FileExists($gamedir & "\" & $exe) Then
	If MsgBox(4, $title, "RD3.exe found!     Should i create registry entries for this place?") = 6 Then
		While $local <> "ger" And $local <> "eur" And $local <> "aus"
			$local = InputBox($title, "Please enter your Game variant.@CRLF@@CRLF@eur for ToCa RaceDriver 3@CRLF@ger for DTM RaceDriver 3@CRLF@aus for V8 Supercars 3", "", "")
			If @error Then
				Exit
			EndIf
		WEnd

		Switch $local
			Case "ger"
				$name = $name_ger
			Case "aus"
				$name = $name_aus
			Case "eur"
				$name = $name_eur
		EndSwitch

		While $lang <> "ger" And $local <> "eng" And $local <> "fre" And $local <> "ita" And $local <> "spa"
			$lang = InputBox($title, "Please enter your language.@CRLF@ger, eng, fre, ita or spa", "", "")
			If @error Then
				Exit
			EndIf
		WEnd

		RegWrite($regpath, "LANGUAGE", "REG_SZ", $lang)
		RegWrite($regpath, "SKU", "REG_SZ", $local)
		RegWrite($regpath, "PATH_MAIN", "REG_SZ", $gamedir & "\gamedata")
		RegWrite($regpath, "PATH_APPLICATION", "REG_SZ", $gamedir)
		RegWrite($regpath, "PATH_SAVE", "REG_SZ", $gamedir & "\savedata")
		RegWrite($regpath, "PATH_VIDEO", "REG_SZ", $gamedir & "\gamedata")
		RegWrite($regpath, "PATH_CD", "REG_SZ", $gamedir)
		RegWrite($regpath, "NAME_APPLICATION", "REG_SZ", $name)
		RegWrite($regpath, "NAME_CD", "REG_SZ", $name)
		RegWrite($regpath, "TITLEBAR", "REG_SZ", $name)
		RegWrite($regpath, "NO_DISC", "REG_SZ", "Please insert disc: " & $name)
		RegWrite($regpath, "NO_DRIVE", "REG_SZ", "Please insert disc: " & $name)
		RegWrite($regpath, "WRONG_DISC", "REG_SZ", "Please insert disc: " & $name)
		RegWrite($regpath & "\Keys")

		If MsgBox(4, $title, "Should i place Desktop and StartMenu shortcuts?") = 6 Then
			FileCreateShortcut($gamedir & "\" & $exe, @DesktopDir & "\" & $name & ".lnk")
			FileCreateShortcut($gamedir & "\" & $exe, @StartMenuDir & "\" & $name & ".lnk")
		EndIf

		MsgBox(0, $title, "Complete. Thanks for using.")
	EndIf
EndIf

Exit

